/*-
 * Copyright (C) 2007 Erik Larsson
 * 
 * All rights reserved.
 * 
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA
 */

import java.util.Calendar;

public class Stat {
//     public static final Date osxEpoch;
//     static {
// 	Calendar c = Calendar.getInstance();
// 	c.setTime(new Date(0));
// 	c.set(Calendar.YEAR = 
	
    public static final short S_IFMT   = (short)0170000; /* type of file (bitmask)*/
    public static final short S_IFIFO  = (short)0010000; /* named pipe (fifo) */
    public static final short S_IFCHR  = (short)0020000; /* character special */
    public static final short S_IFDIR  = (short)0040000; /* directory */
    public static final short S_IFBLK  = (short)0060000; /* block special */
    public static final short S_IFREG  = (short)0100000; /* regular */
    public static final short S_IFLNK  = (short)0120000; /* symbolic link */
    public static final short S_IFSOCK = (short)0140000; /* socket */
    public static final short S_IFWHT  = (short)0160000; /* whiteout */
    public static final short S_ISUID  = (short)0004000; /* set user id on execution */
    public static final short S_ISGID  = (short)0002000; /* set group id on execution */
    public static final short S_ISVTX  = (short)0001000; /* save swapped text even after use */
    public static final short S_IRUSR  = (short)0000400; /* read permission, owner */
    public static final short S_IWUSR  = (short)0000200; /* write permission, owner */
    public static final short S_IXUSR  = (short)0000100; /* execute/search permission, owner */

    public short st_mode; /* inode protection mode */
    public byte st_nlink; /* number or hard links to the file */
    public long st_size; /* file size, in bytes */

    /* Time of last access */
    public int atime_tm_sec;   // seconds [0,61]
    public int atime_tm_min;   // minutes [0,59]
    public int atime_tm_hour;  // hour [0,23]
    public int atime_tm_mday;  // day of month [1,31]
    public int atime_tm_mon;   // month of year [0,11]
    public int atime_tm_year;  // years since 1900
    public int atime_tm_wday;  // day of week [0,6] (Sunday = 0)
    public int atime_tm_yday;  // day of year [0,365]
    public int atime_tm_isdst; // daylight savings flag (positive: DST is in effet, 0: DST is not in effect, -1: information not available)

    public long atime_tv_sec;
    
    /* Time of last modification */
    public int mtime_tm_sec;   // seconds [0,61]
    public int mtime_tm_min;   // minutes [0,59]
    public int mtime_tm_hour;  // hour [0,23]
    public int mtime_tm_mday;  // day of month [1,31]
    public int mtime_tm_mon;   // month of year [0,11]
    public int mtime_tm_year;  // years since 1900
    public int mtime_tm_wday;  // day of week [0,6] (Sunday = 0)
    public int mtime_tm_yday;  // day of year [0,365]
    public int mtime_tm_isdst; // daylight savings flag (positive: DST is in effet, 0: DST is not in effect, -1: information not available)

    public long mtime_tv_sec;
    
    /* Creation time */
    public int ctime_tm_sec;   // seconds [0,61]
    public int ctime_tm_min;   // minutes [0,59]
    public int ctime_tm_hour;  // hour [0,23]
    public int ctime_tm_mday;  // day of month [1,31]
    public int ctime_tm_mon;   // month of year [0,11]
    public int ctime_tm_year;  // years since 1900
    public int ctime_tm_wday;  // day of week [0,6] (Sunday = 0)
    public int ctime_tm_yday;  // day of year [0,365]
    public int ctime_tm_isdst; // daylight savings flag (positive: DST is in effet, 0: DST is not in effect, -1: information not available)
    
    public long ctime_tv_sec;
    
    public void setAccessTime(Calendar c) {
	atime_tv_sec = c.getTime().getTime()/1000;
	System.err.println("  NOTE: Setting atime_tv_sec to " + atime_tv_sec);
	atime_tm_sec = c.get(Calendar.SECOND);
	atime_tm_min = c.get(Calendar.MINUTE);
	atime_tm_hour = c.get(Calendar.HOUR_OF_DAY);
	atime_tm_mday = c.get(Calendar.DAY_OF_MONTH);
	atime_tm_mon = c.get(Calendar.MONTH);
	atime_tm_year = c.get(Calendar.YEAR)-1900;
	int dow =  c.get(Calendar.DAY_OF_WEEK);
	switch(dow) {
	case Calendar.SUNDAY:
	    atime_tm_wday = 0;
	    break;
	case Calendar.MONDAY:
	    atime_tm_wday = 1;
	    break;
	case Calendar.TUESDAY:
	    atime_tm_wday = 2;
	    break;
	case Calendar.WEDNESDAY:
	    atime_tm_wday = 3;
	    break;
	case Calendar.THURSDAY:
	    atime_tm_wday = 4;
	    break;
	case Calendar.FRIDAY:
	    atime_tm_wday = 5;
	    break;
	case Calendar.SATURDAY:
	    atime_tm_wday = 6;
	    break;
	}
	atime_tm_yday = c.get(Calendar.DAY_OF_YEAR);
	atime_tm_isdst = -1;
    }
    public void setModifyTime(Calendar c) {
	mtime_tv_sec = c.getTime().getTime()/1000;
	mtime_tm_sec = c.get(Calendar.SECOND);
	mtime_tm_min = c.get(Calendar.MINUTE);
	mtime_tm_hour = c.get(Calendar.HOUR_OF_DAY);
	mtime_tm_mday = c.get(Calendar.DAY_OF_MONTH);
	mtime_tm_mon = c.get(Calendar.MONTH);
	mtime_tm_year = c.get(Calendar.YEAR)-1900;
	int dow =  c.get(Calendar.DAY_OF_WEEK);
	switch(dow) {
	case Calendar.SUNDAY:
	    mtime_tm_wday = 0;
	    break;
	case Calendar.MONDAY:
	    mtime_tm_wday = 1;
	    break;
	case Calendar.TUESDAY:
	    mtime_tm_wday = 2;
	    break;
	case Calendar.WEDNESDAY:
	    mtime_tm_wday = 3;
	    break;
	case Calendar.THURSDAY:
	    mtime_tm_wday = 4;
	    break;
	case Calendar.FRIDAY:
	    mtime_tm_wday = 5;
	    break;
	case Calendar.SATURDAY:
	    mtime_tm_wday = 6;
	    break;
	}
	mtime_tm_yday = c.get(Calendar.DAY_OF_YEAR);
	mtime_tm_isdst = -1;
    }
    public void setCreateTime(Calendar c) {
	ctime_tv_sec = c.getTime().getTime()/1000;
	ctime_tm_sec = c.get(Calendar.SECOND);
	ctime_tm_min = c.get(Calendar.MINUTE);
	ctime_tm_hour = c.get(Calendar.HOUR_OF_DAY);
	ctime_tm_mday = c.get(Calendar.DAY_OF_MONTH);
	ctime_tm_mon = c.get(Calendar.MONTH);
	ctime_tm_year = c.get(Calendar.YEAR)-1900;
	int dow =  c.get(Calendar.DAY_OF_WEEK);
	switch(dow) {
	case Calendar.SUNDAY:
	    ctime_tm_wday = 0;
	    break;
	case Calendar.MONDAY:
	    ctime_tm_wday = 1;
	    break;
	case Calendar.TUESDAY:
	    ctime_tm_wday = 2;
	    break;
	case Calendar.WEDNESDAY:
	    ctime_tm_wday = 3;
	    break;
	case Calendar.THURSDAY:
	    ctime_tm_wday = 4;
	    break;
	case Calendar.FRIDAY:
	    ctime_tm_wday = 5;
	    break;
	case Calendar.SATURDAY:
	    ctime_tm_wday = 6;
	    break;
	}
	ctime_tm_yday = c.get(Calendar.DAY_OF_YEAR);
	ctime_tm_isdst = -1;
    }
 }


// STAT(2)                     BSD System Calls Manual                    STAT(2)

// NAME
//      stat, lstat, fstat -- get file status

// SYNOPSIS
//      #include <sys/types.h>
//      #include <sys/stat.h>

//      int
//      stat(const char *path, struct stat *sb);

//      int
//      lstat(const char *path, struct stat *sb);

//      int
//      fstat(int fd, struct stat *sb);

// DESCRIPTION
//      The stat() function obtains information about the file pointed to by
//      path.  Read, write or execute permission of the named file is not
//      required, but all directories listed in the path name leading to the file
//      must be searchable.

//      Lstat() is like stat() except in the case where the named file is a sym-
//      bolic link, in which case lstat() returns information about the link,
//      while stat() returns information about the file the link references.
//      Unlike other filesystem objects, symbolic links do not have an owner,
//      group, access mode, times, etc.  Instead, these attributes are taken from
//      the directory that contains the link.  The only attributes returned from
//      an lstat() that refer to the symbolic link itself are the file type
//      (S_IFLNK), size, blocks, and link count (always 1).

//      The fstat() obtains the same information about an open file known by the
//      file descriptor fd.

//      The sb argument is a pointer to a stat() structure as defined by

//      The sb argument is a pointer to a stat() structure as defined by
//      <sys/stat.h> (shown below) and into which information is placed concern-
//      ing the file.

//      struct stat {
//          dev_t    st_dev;    /* device inode resides on */
//          ino_t    st_ino;    /* inode's number */
//          mode_t   st_mode;   /* inode protection mode */
//          nlink_t  st_nlink;  /* number or hard links to the file */
//          uid_t    st_uid;    /* user-id of owner */
//          gid_t    st_gid;    /* group-id of owner */
//          dev_t    st_rdev;   /* device type, for special file inode */
//          struct timespec st_atimespec;  /* time of last access */
//          struct timespec st_mtimespec;  /* time of last data modification */
//          struct timespec st_ctimespec;  /* time of last file status change */
//          off_t    st_size;   /* file size, in bytes */
//          quad_t   st_blocks; /* blocks allocated for file */
//          u_long   st_blksize;/* optimal file sys I/O ops blocksize */
//          u_long   st_flags;  /* user defined flags for file */
//          u_long   st_gen;    /* file generation number */
//      };

//      The time-related fields of struct stat are as follows:

//      st_atime     Time when file data last accessed.  Changed by the mknod(2),
//                   utimes(2) and read(2) system calls.

//      st_mtime     Time when file data last modified.  Changed by the mknod(2),
//                   utimes(2) and write(2) system calls.

//      st_ctime     Time when file status was last changed (inode data modifica-
//                   tion).  Changed by the chmod(2), chown(2), link(2),
//                   mknod(2), rename(2), unlink(2), utimes(2) and write(2) sys-
//                   tem calls.

//      The size-related fields of the struct stat are as follows:

//      st_blksize     The optimal I/O block size for the file.

//      st_blocks      The actual number of blocks allocated for the file in
//                     512-byte units.  As short symbolic links are stored in the
//                     inode, this number may be zero.

//      The status information word st_mode has the following bits:

//      #define S_IFMT 0170000           /* type of file */
//      #define        S_IFIFO  0010000  /* named pipe (fifo) */
//      #define        S_IFCHR  0020000  /* character special */
//      #define        S_IFDIR  0040000  /* directory */
//      #define        S_IFBLK  0060000  /* block special */
//      #define        S_IFREG  0100000  /* regular */
//      #define        S_IFLNK  0120000  /* symbolic link */
//      #define        S_IFSOCK 0140000  /* socket */
//      #define        S_IFWHT  0160000  /* whiteout */
//      #define S_ISUID 0004000  /* set user id on execution */
//      #define S_ISGID 0002000  /* set group id on execution */
//      #define S_ISVTX 0001000  /* save swapped text even after use */
//      #define S_IRUSR 0000400  /* read permission, owner */
//      #define S_IWUSR 0000200  /* write permission, owner */
//      #define S_IXUSR 0000100  /* execute/search permission, owner */

//      For a list of access modes, see <sys/stat.h>, access(2) and chmod(2).

// RETURN VALUES
//      Upon successful completion a value of 0 is returned.  Otherwise, a value
//      of -1 is returned and errno is set to indicate the error.

// COMPATIBILITY
//      Previous versions of the system used different types for the st_dev,
//      st_uid, st_gid, st_rdev, st_size, st_blksize and st_blocks fields.

// ERRORS
//      Stat() and lstat() will fail if:

//      [ENOTDIR]          A component of the path prefix is not a directory.

//      [ENAMETOOLONG]     A component of a pathname exceeded {NAME_MAX} charac-
//                         ters, or an entire path name exceeded {PATH_MAX} char-
//                         acters.

//      [ENOENT]           The named file does not exist.

//      [EACCES]           Search permission is denied for a component of the
//                         path prefix.

//      [ELOOP]            Too many symbolic links were encountered in translat-
//                         ing the pathname.

//      [EFAULT]           Sb or name points to an invalid address.

//      [EIO]              An I/O error occurred while reading from or writing to
//                         the file system.

//      Fstat() will fail if:

//      [EBADF]            fd is not a valid open file descriptor.

//      [EFAULT]           Sb points to an invalid address.

//      [EIO]              An I/O error occurred while reading from or writing to
//                         the file system.

// CAVEATS
//      The file generation number, st_gen, is only available to the super-user.
//      The fields in the stat structure currently marked st_spare1, st_spare2,
//      and st_spare3 are present in preparation for inode time stamps expanding
//      to 64 bits.  This, however, can break certain programs that depend on the
//      time stamps being contiguous (in calls to utimes(2)).

// SEE ALSO
//      chmod(2), chown(2), utimes(2) symlink(7)

// BUGS
//      Applying fstat to a socket (and thus to a pipe) returns a zero'd buffer,
//      except for the blocksize field, and a unique device and inode number.

// STANDARDS
//      The stat() and fstat() function calls are expected to conform to IEEE Std
//      1003.1-1988 (``POSIX.1'').

// HISTORY
//      An lstat() function call appeared in 4.2BSD.

// 4th Berkeley Distribution       April 19, 1994       4th Berkeley Distribution

	 